function sol_smooth = ImgSmooth(sol, maskTest)
%--------------------------------------------------------------------------
%   This program is to do inpainting accrording to given mask
%    
%   Usage: sol_smooth = ImgSmooth(sol, maskTest)
%
%   Inputs: 
%       - sol: given image
%       - maskTest: given mask
%
%   Outputs: 
%       - sol_smooth: smoothed result
% 
%   Code by: Xiaohao Cai
%   Last updated: 28/03/2018
%--------------------------------------------------------------------------

[xLen,yLen] = size(sol);
maskAll=zeros(xLen,yLen);
% generate mask
for i=1:length(maskTest)
    maskAll = maskAll + maskTest{i};
end

maskAll = double(maskAll > 0.5);

% smoothing
sol_smooth_temp = imgaussfilt(sol,6);
sol_smooth = sol.*(1-maskAll)+sol_smooth_temp.*maskAll;



