function maskTest = MaskGet(im,imgName)
%--------------------------------------------------------------------------
%   This program is to generate mask used to do hypothesis test
%    
%   Usage: maskTest = MaskGet(im,imgName)
%
%   Inputs: 
%       - im: given image
%       - imgName: given area of interest, and find an credible region for it
%
%   Outputs: 
%       - maskTest: mask containing area to test
% 
%   Code by: Xiaohao Cai
%   Last updated: 02/10/2016 
%--------------------------------------------------------------------------

% test_image = {'M31', 'CYN', 'W28', '3c288'};

[xLen,yLen] = size(im);

if strcmp('M31', imgName)
%     % upper, down, all areas
%     areaIdx = {[130, 145, 48, 70], [145, 180, 30, 65], ...
%         [130, 180, 30, 70], [127, 137, 190, 205]};  
    % one area
    areaIdx = {[145, 180, 30, 65]};  
end

if strcmp('CYN', imgName)
%     % middle, left, right areas
%     areaIdx = {[130, 150, 220, 255], [210, 255, 4, 55], [20, 75, 450, 510]}; 
    % one area
    areaIdx = {[125, 158, 220, 257]}; 
end

if strcmp('W28', imgName)
%     % from left to right
%     areaIdx = {[88, 120, 10, 40], [80, 180, 47, 125], ...
%         [113, 140, 147, 180], [65, 93, 175, 210]};  
    % one area
    areaIdx = {[88, 120, 10, 40]};  
end

if strcmp('3c288', imgName)
%     % middle, up, down areas
%     areaIdx = {[119, 141, 88, 120], [70, 118, 80, 165], [140,180, 70, 170]}; 
    % one area
%     areaIdx = {[119, 141, 88, 120]};  
%     areaIdx = {[15, 35, 157, 181]};
%     areaIdx = {[119, 141, 88, 120],[15, 35, 157, 181]};
    areaIdx = {[119, 141, 88, 120],[10, 40, 150, 190]};
end

% generage mask
for i=1:length(areaIdx)
    maskTest{i} = zeros(xLen,yLen);
    maskTest{i}(areaIdx{i}(1):areaIdx{i}(2), areaIdx{i}(3):areaIdx{i}(4)) = 1;
end 
    


